
function removeImage(id)
	if (id ~= nil) then
		freeimage(id)
	end
end

function pointInRect(px,py,x,y,w,h)
	return(px > x and py > y and px < x + w and py < y + h)
end

function table.map_length(t)
	local c = 0
	for k,v in pairs(t) do
		c = c+1
	end
	return c
end

function nilZero(number, var)
	if (number ~= nil) then
		return(number)
	end
	if var then
		return(var)
	end
	return(0)
end

function closeHudText(id,iid)
	parse('hudtxt2 '..id..' '..iid..' "" 0 0')
end

function hudText2(id, i, text,x,y, align)
	align = nilZero(align)
	parse('hudtxt2 '..id..' '..i..' "'..text..'" '..x..' '..y..' '..align)
end

function SpawnEffect(effect,x,y,p1,p2,r,g,b)
	parse('effect "'..effect..'" '..x..' '..y..' '..p1..' '..p2..' '..r..' '..g..' '..b)
end

function removeFadeImage(id)
	id = tonumber(id)
	if FadeImageList[id] then
		freeimage(id)
	end
end

FadeImageList = {}
function FadeStartround()
	FadeImageList = {}	
end
AddGlobalFunction("startround",FadeStartround)
function fadeImageEffect(id,path,x,y, ms, scale)
	if (CFG_EFFECT_MENU_FADE_OUT ~= true) then
		return
	end
	effect = image(path,x,y,2,id)
	imageblend(effect,1)
	if ms == nil then
		ms = 100 		
	end
	if scale then
		tween_scale(effect,ms * 2,1,0)
	end
	tween_alpha(effect,ms,0)
	timer(200,"removeFadeImage",effect)
	FadeImageList[effect] = true
end

function setKnife(id)
	parse("setweapon "..id..' 50') 
end

function loadImage(path,x , y,mode,id,rot,blend,scaleX,scaleY)
	local img = image(path,x , y,mode,id)
	if rot then
		imagepos(img,x ,y, rot)
	end
	if blend then
		imagepos(img,blend)
	end
	if scaleX and scaleY then
		imagescale(img,scaleX,scaleY)
	end
	return(img)
end

function PrintDebug(txt)
	if CFG_DEBUG then
		print("160160255[DEBUG] "..txt)
	end
end
function PrintHookDebug(txt)
	if CFG_DEBUG_HOOK then
		print("160160255[HOOK TIME] "..txt)
	end
end

function PrintErrorDebug(txt)
	if CFG_DEBUG_HOOK then
		print("255000000[ERROR] "..txt)
	end
end

function distance(x1,y1,x2,y2)
	local xd = x2 - x1
	local yd = y2 - y1
	return( math.sqrt(xd*xd + yd*yd) )
end

function DrawLineForPlayer(path,id,x1,y1,x2,y2)
	if x1 == nil or y2 == nil or x2 == nil or y2 == nil then
		return
	end
	local mX = (x1 + x2) / 2
	local mY = (y1 + y2) / 2
	local d = distance(x1,y1,x2,y2) 
	local r = math.deg(math.atan2(y1-y2,x1-x2))
	local img = image("gfx/stats/ui/"..path..".png",mX,mY,2,id)
	imagescale(img,d/100,1)
	imagepos(img,mX,mY,r)
	return(img)
end

function DrawRect(path,id,x,y,w,h)
	local img = image("gfx/stats/ui/"..path..".png",x  + w / 2,y  + h / 2,2,id)
	imagescale(img,w/32,h/32)
	return(img)
end

